define(["app",'hbs!js/categories/init','js/categories/service'], function(App, InitView, Service) {
															   
	
	var bindings = [{
		element: '.page[data-page="categories"]',
		selector: '.category-note',
		event: 'click',
		handler: openThisPage
	}];
	
	var categoryId;
	
	function init(query){
		if(!query.categoryId)
		return;
		
		categoryId = query.categoryId;
		
		getInitInfo();
		App.utils.bindEvents(bindings);
	}
			
	function getInitInfo(){
		t7.showIndicator();
		
		Service.getInitInfo(categoryId, function(response){
			setTimeout(function(){
				renderInitInfo(response);
				t7.hideIndicator();	
			},1000);
		});	
	}
	
	function renderInitInfo(response){
		var output = {};
		output.category_info = response.category_info;
		output.category_list = response.category_list;
		
		var content = InitView(output);
		$$('.categories-title').html(response.category_info.name);
		
		var container = $$('.page[data-page="categories"]');
		container.find('.content-categories').html(content);
	}
	
	function openThisPage(){
		var pageUrl = $$(this).data('url');
        App.utils.loadPage(pageUrl);	
	}
	
	return {
		init:init	
	};



});