define(["app",'hbs!js/category/init','js/category/service'], function(App, InitView, Service) {
															   
	
	var bindings = [{
		element: '#category',
		event: 'show',
		handler: initInfo
	},{
		element: '.page[data-page="category"]',
		selector: '.category-item',
		event: 'click',
		handler: openThisPage
	},{
		element: '.page[data-page="category"]',
		selector: '.search-bar',
		event: 'click',
		handler: openSearchPage
	},{
		element: '.page[data-page="category"]',
		selector: '.pull-to-refresh-content',
		event: 'refresh',
		handler: getRefreshInfo
	}];
	
	function init(){
		App.utils.bindEvents(bindings);
	}
	
	function initInfo(){
		if($$('#category .category-item').length > 0) {
            return false;
        }else {
            getInitInfo();
            return true;
        }
	}
	
	function getRefreshInfo(){
		getInitInfo();
		t7.pullToRefreshDone();	
	}
			
	function getInitInfo(){
		t7.showIndicator();
		
		Service.getInitInfo(function(response){
			setTimeout(function(){
				renderInitInfo(response);
				t7.hideIndicator();	
			},1000);
		});	
	}
	
	function renderInitInfo(response){
		var output = {};
		output.category_list = response;
		
		var content = InitView(output);
		var container = $$('.page[data-page="category"]');
		container.find('.category-wrap').html(content);
	}
	
	function openThisPage(){
		var pageUrl = $$(this).data('url');
        App.utils.loadPage(pageUrl);
	}
	
	function openSearchPage(){
		var pageUrl = 'page/search.html';
		App.utils.loadPage(pageUrl);
	}
		
	return {
		init:init	
	};



});