define(['app', 'hbs!js/feedback/init','js/feedback/service','js/mark'], function( App, InitView, Service,Mark){
	
	var bindings = [{
		element: '.page[data-page="feedback"]',
		selector: '.submit',
		event: 'click',
		handler: saveFeedback
	}];
	
	function init(){
		getInitInfo();
		App.utils.bindEvents(bindings);
	}
	
	function getInitInfo(){
		var content = InitView();
		var container = $$('.page[data-page="feedback"]');
		container.find('.content-feedback').html(content);
	}
	
	function saveFeedback(){
		var content = $$('#content').val();
		var contact = $$('#contact').val();
		
		if(App.utils.getCharLength(content) == 0){
			window.plugins.toast.show('想对涂涂说些什么呢?',"short",'center');
		    return;
        }
		if(App.utils.getCharLength(contact) == 0){
			window.plugins.toast.show('请留下的您的邮箱',"short",'center');
			return;
        }
		
		setFeedback(content,contact);
	}
	
	function setFeedback(content, contact){
		t7.showIndicator();
		var appInfo = Mark.getAppInfo();
		Service.getInitInfo(content, contact, appInfo, function(){
			setTimeout(function(){	
				t7.hideIndicator();
				App.utils.backPage();
				window.plugins.toast.show('我们收到啦! 谢谢~',"short",'center');
			},1000);
		});		
	}
	
	return {
		init:init
	};
	
});