define(["app",'hbs!js/login/init','js/login/service','js/mark'], function(App, InitView, Service, Mark) {
	
	var bindings = [{
		element: '.popup-login',
		selector: '.close-button',
		event: 'click',
		handler: closePopup
	},{
		element: '.popup-login',
		selector: '.forget-password',
		event: 'click',
		handler: findPassword
	},{
		element: '.popup-login',
		selector: '.submit',
		event: 'click',
		handler: checkLogin
	}];
		
	function init(){
		t7.popup(InitView());
		App.utils.bindEvents(bindings);
	}
	
	function checkLogin(){
		var email = $$('#email').val();
		var password = $$('#password').val();
		
		if(App.utils.getCharLength(email) === 0){
		   window.plugins.toast.show('请输入邮箱帐号',"short",'center');
		   return;
		} 
		
		if(!App.utils.isEmail(email)){
		   window.plugins.toast.show('邮箱格式不正确',"short",'center');
		   return;
		} 
		
		if(App.utils.getCharLength(password) === 0){
		   window.plugins.toast.show('请输入密码',"short",'center');
		   return;
		}
		
		userLogin(email,password);
	}
	
	function userLogin(email,password){
		t7.showIndicator();	
		
		var appInfo = Mark.getAppInfo();
		Service.getInitInfo(email, password, appInfo, function(response){
			setTimeout(function(){
				t7.hideIndicator();
				if(response.code == 400){
					window.plugins.toast.show('用户名或密码错误',"short",'center');
				}
				if(response.code == 200){
					successLogin(response.data);
				}
			},1200);
		});	
	}
	
	function successLogin(response){
		Mark.setCurrentMark(response);
		var homeUrl = 'page/home.html';
		var pageUrl = 'page/user.html';
		mainView.router.loadPage(homeUrl);
		userView.router.reloadPage(pageUrl);
		t7.closeModal();
	}
	
	function findPassword(){
		var staticInfo = Mark.getStaticInfo();
		var options = App.utils.getBrowserOptions('找回密码');
		cordova.ThemeableBrowser.open(staticInfo.user_forget_url, '_blank', options);		
	}
		
	function closePopup(){
		t7.closeModal('.popup-login');	
		t7.hideIndicator();
	}
	
	return {
		init:init
	};



});