define(["app",'hbs!js/register/init','js/register/service','js/mark'], function(App, InitView, Service, Mark) {
	
	var bindings = [{
		element: '.popup-register',
		selector: '.close-button',
		event: 'click',
		handler: closePopup
	},{
		element: '.popup-register',
		selector: '.user-rule',
		event: 'click',
		handler: userRule
	},{
		element: '.popup-register',
		selector: '.submit',
		event: 'click',
		handler: checkRegister
	}];
		
	function init(){
		t7.popup(InitView());
		App.utils.bindEvents(bindings);
	}
	
	function checkRegister(){
		var email = $$('#email').val();
		var	password = $$('#password').val();
		var	repassword = $$('#repassword').val();
		var	nick = $$('#nick').val();
		
		if(App.utils.getCharLength(email) === 0){
			window.plugins.toast.show('请输入邮箱地址',"short",'center');
		    return;
		} 
		
		if(!App.utils.isEmail(email)){
			window.plugins.toast.show('邮箱格式不正确',"short",'center');
		    return;	
		}
		
		if(App.utils.getCharLength(password) === 0){
			window.plugins.toast.show('请输入密码',"short",'center');
		    return;	
		}
		
		if( App.utils.getCharLength(password) < 6){
			window.plugins.toast.show('密码长度6-20位',"short",'center');
			return;	
		}
		
		if(App.utils.getCharLength(repassword) === 0){
			window.plugins.toast.show('请再次确认密码',"short",'center');
		    return;	
		}
		
		if( password !== repassword){
			window.plugins.toast.show('两次密码不一致',"short",'center');
			return;	
		}
		
		if(App.utils.getCharLength(nick) === 0){
			window.plugins.toast.show('请输入昵称',"short",'center');
		    return;	
		}
		
		userRegister(email, password, nick);
	}
	
	function userRegister(email, password, nick){
		t7.showIndicator();	
		
		var appInfo = Mark.getAppInfo();
		Service.getInitInfo(email, password, nick, appInfo, function(response){
			setTimeout(function(){
				t7.hideIndicator();
				if(response.length == 0){
					window.plugins.toast.show('此邮箱已被注册',"short",'center');
				}
				if(response.length !== 0){
					successRegister(response);
				}
			},1200);
		});	
	}
	
	function successRegister(response){
		Mark.setCurrentMark(response);
		var homeUrl = 'page/home.html';
		var pageUrl = 'page/user.html';
		mainView.router.loadPage(homeUrl);
		userView.router.reloadPage(pageUrl);
		t7.closeModal();
	}
	
	function userRule(){
		var settingsInfo = Mark.getStaticInfo();
		var options = App.utils.getBrowserOptions('用户使用协议');
		cordova.ThemeableBrowser.open(settingsInfo.user_rule_url, '_blank', options);		
	}
	
	function closePopup(){
		t7.closeModal('.popup-register');
		t7.hideIndicator();
	}
	
	return {
		init:init
	};



});