define(['app','hbs!js/search/init', 'js/search/service'],function(App, InitView, Service){
	
	var bindings = [{
		element: '.page[data-page="search"]',
		selector: '.search-item',
		event: 'click',
		handler: openContentPage
	}];
		
	var keyWord;
	var pageId;
	
	function init(query){
		getSearchInfo();
		App.utils.bindEvents(bindings);
	}
	
	function getSearchInfo(){
		var searchContainer = $$('.page[data-page="search"]');
		var searchBar = t7.searchbar(searchContainer.find('.searchbar'), {
			customSearch: true,
			onSearch: function (s, q) {
				getInitInfo(s.query);
				keyWord = s.query;
			},
			onClear: function (s) {
				//searchContainer.find('.search-wrap').html('');
			}
		});
		searchContainer.find('input[type="search"]').on('keyup', function (e) {
			if (e.keyCode === 13){
				$$('input[type="search"]')[0].blur();
			}
		});
	}
	
	function getInitInfo(keyWord){				
		Service.getInitInfo(keyWord, function(response){
			setTimeout(function(){
				renderInitInfo(response);
			},500);
		});
		
	}
	

	function renderInitInfo(response){
		var output = {};
		output.search_list = response;
		
		var content = InitView(output);
		var container = $$('.page[data-page="search"]');
		container.find('.search-wrap').html(content);	
	}
	
	function openContentPage(){
		var pageUrl;
		var $this = $$(this);
		
		if($this.hasClass('search-goods')){
			pageUrl = 'page/searchgoods.html?word=' + keyWord;
		}
		
		if($this.hasClass('search-posts')){
			pageUrl = 'page/searchposts.html?word=' + keyWord;
		}
		
		if($this.hasClass('search-label')){
			pageUrl = 'page/searchlabel.html?word=' + keyWord;
		}
		
		App.utils.loadPage(pageUrl);
	}
	
	
	return {
		init:init	
	};
	
});