define(['app','hbs!js/searchlabel/init','hbs!js/searchlabel/infinite','js/searchlabel/service'],function(App, InitView, InfiniteView, Service){
	
	var bindings = [{
		element: '.page[data-page="searchlabel"]',
		selector: '.infinite-scroll',
		event: 'infinite',
		handler: getInfiniteInfo
	},{
		element: '.page[data-page="searchlabel"]',
		selector: '.tag-item',
		event: 'click',
		handler: openThisPage
	}];
	
	var word;
	var pageId;
	
	function init(query){
		if(!query.word)
		return;
		
		word = query.word;	
		
		getInitInfo();
		App.utils.bindEvents(bindings);
	}
		
	function getInitInfo(){
		pageId = 2;
		
		var container = $$('.page[data-page="searchlabel"]');
		var loading = container.find('.infinite-scroll');
		loading.data('on',false);
		
		t7.showIndicator();
		t7.attachInfiniteScroll(loading);
		
		Service.getInitInfo(word, function(response){
			setTimeout(function(){
				renderInitInfo(response);
				t7.hideIndicator();	
			},1000);
		});		
	}
	
	function getInfiniteInfo(){		
		var container = $$('.page[data-page="searchlabel"]');
		var loading = container.find('.infinite-scroll');
		if(loading.data('on')) return;
		
		loading.data('on',true);
		App.utils.showPreloader(container);
		
		Service.getInfiniteInfo(word, pageId, function(response){
			setTimeout(function(){
				if(response.length == 0){
					t7.detachInfiniteScroll(loading);
					App.utils.hidePreloader(container);
				}else{
					pageId = pageId + 1;	
					renderInfiniteInfo(response);
					loading.data('on',false);
				}
			},500);
		});	
	}
	
	function renderInitInfo(response){
		var output = {};
		output.tag_list = response;
		
		var content = InitView(output);
		$$('.key-word-title').html(word);
		
		var container = $$('.page[data-page="searchlabel"]');
		container.find('.tag-wrap').html(content);
		
		t7.initImagesLazyLoad(container);
	}
	
	function renderInfiniteInfo(response){
		var output = {};
		output.tag_list = response;
		
		var content = InfiniteView(output);
		var container = $$('.page[data-page="searchlabel"]');
		container.find('.tag-wrap').append(content);
	}
	
	function openThisPage(){
		var pageUrl = $$(this).data('url');
		App.utils.loadPage(pageUrl);	
	}
	
	return {
		init:init	
	};
	
});