define(["app","js/mark", 'hbs!js/setavatar/init'], function(App, Mark, InitView) {
	
	var bindings = [{
		element: '.page[data-page="setavatar"]',
		selector: '.setavatar',
		event: 'click',
		handler: setAvatar
	}];
	
	var markId;
		
	function init(){
		markId = Mark.getCurrentMarkId();
		if(!markId || markId == '')
		return;

		getInitInfo();
		App.utils.bindEvents(bindings);
	}
	
	function getInitInfo(){
		var content = InitView();
		var container = $$('.page[data-page="setavatar"]');
		container.find('.content-setavatar').html(content);	
	}
	
	function setAvatar(){
		var $this = $$(this);
		var network = App.utils.checkConnection();
		var quality, sourceType;

		if(network === 'WiFi connection'){
            quality = 80;
        }else{
            quality = 50;
        }
		
		if($this.hasClass('camera')){
			sourceType = Camera.PictureSourceType.CAMERA;
        }else if($this.hasClass('photo')){
            sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
        }else{
			return;	
		}
		
		var setOptions = {
			quality: quality,
			allowEdit: false,
			sourceType: sourceType,
			mediaType: Camera.MediaType.PICTURE,
			targetWidth: 640,
			targetHeight: 640
		};
		
		navigator.camera.getPicture(
			setSuccess, 
			setFail, 
			setOptions
		);
	}
	
	function setSuccess(fileURL){
		var uploadOptions = new FileUploadOptions;
		uploadOptions.fileKey = "file";
		uploadOptions.mimeType = "image/jpeg";
		uploadOptions.params = {
			mark_id: markId
		};
		
		var fileUPload = new FileTransfer;
		var settingsInfo = Mark.getStaticInfo();
		var serverURL = encodeURI(settingsInfo.set_avatar_url);
		
		$$('.output-user-content .radius-avatar').attr('src',fileURL).show();
		fileUPload.upload(fileURL, serverURL, uploadSuccess, uploadFail, uploadOptions);
	}
	
	function setFail(){
		window.plugins.toast.show('请选择照片',"short",'center');
	}
	
	function uploadSuccess(){
		App.utils.backPage();
		window.plugins.toast.show('修改成功',"short",'center');
	}
	
	function uploadFail(){
		App.utils.backPage();
		window.plugins.toast.show('修改失败',"short",'center');
	}
	
	return {
		init:init
	};



});