define(['app','hbs!js/setnick/init', 'js/mark', 'js/setnick/service'], function(App, InitView, Mark, Service) {
	
	
	var bindings = [{
		element: '.page[data-page="setnick"]',
		selector: '.submit',
		event: 'click',
		handler: saveNick
	}];
	
	
	function init(){
		getUserInfo();
		App.utils.bindEvents(bindings);
	}
	
	function getUserInfo(){	
		var userNick = $$('.page[data-page="user"]').find(".user-nick").text();
		var output = {};
		output.nick = userNick;
		
		var content = InitView(output);
		var container = $$('.page[data-page="setnick"]');
		container.find('.content-setnick').html(content);
	}
	
	function writingNick(nick){
		$$('.page[data-page="user"] .user-nick').text(nick);
		$$('.page[data-page="setnick"] .output-setnick-content input').val(nick);	
	}

	function saveNick() {
		var nick = $$('#nick').val();
		
		if(App.utils.getCharLength(nick) == 0){
		   window.plugins.toast.show('昵称不能为空',"short",'center');
		   return;
		}
		
		if(App.utils.getCharLength(nick) > 50){
		   window.plugins.toast.show('昵称长度不能超过50位',"short",'center');
		   return;
		}
		
		settingNick(nick);
	}
	
	function settingNick(nick){
		t7.showIndicator();	
		
		var markId = Mark.getCurrentMarkId();
		Service.getInitInfo(markId, nick, function(response){
			setTimeout(function(){
				t7.hideIndicator();
				if(response.code == 400){
					window.plugins.toast.show('昵称中不能包含表情',"short",'center');
				}
				if(response.code == 200){
					writingNick(nick);
					App.utils.backPage();
					window.plugins.toast.show('昵称修改成功',"short",'center');
				}				
			},1200);
		});	
	}
	
	return {
		init:init
	};



});