define(['app','hbs!js/setpass/init','js/mark', 'js/setpass/service'], function(App, InitView, Mark, Service) {
	
	var bindings = [{
		element: '.page[data-page="setpass"]',
		selector: '.submit',
		event: 'click',
		handler: savePassword
	}];
	
	function init(){		
		getInitInfo();
		App.utils.bindEvents(bindings);
	}
	
	function getInitInfo(){
		var output = {};
		var currentPlatId = Mark.getCurrentPlatId();
		var container = $$('.page[data-page="setpass"]');
		
		if(currentPlatId == '3'){
			output.is_modify = true;
		}else{
			output.is_modify = false;
		}
		
		var content = InitView(output);
		container.find('.content-setpass').html(content);		
	}
	
	function savePassword() {
		var currentPassword = $$('#current-password').val();
		var newPassword = $$('#new-password').val();
		var renewPassword = $$('#renew-password').val();
		
		if(App.utils.getCharLength(currentPassword) == 0){
			window.plugins.toast.show('请输入当前密码',"short",'center');
			return;
		}
		
		if(App.utils.getCharLength(newPassword) == 0){
			window.plugins.toast.show('请输入新密码',"short",'center');
			return;
		}
		
		if(App.utils.getCharLength(newPassword) < 6){
			window.plugins.toast.show('新密码不能少于6位',"short",'center');
			return;
		}
		
		if(App.utils.getCharLength(newPassword) > 20){
			window.plugins.toast.show('新密码不能大于20位',"short",'center');
			return;
		}
		
		if(App.utils.getCharLength(renewPassword) == 0){
			window.plugins.toast.show('请再次确认新密码',"short",'center');
			return;
		}
		
		if(newPassword !== renewPassword){
			window.plugins.toast.show('两次密码不一致',"short",'center');
			return;	
		}
		
		settingPassword(currentPassword,newPassword);
	}
	
	function settingPassword(currentPassword, newPassword){
		t7.showIndicator();
		var markId = Mark.getCurrentMarkId();
		Service.getInitInfo(markId, currentPassword, newPassword, function(response){
			setTimeout(function(){
				t7.hideIndicator();
				if(response.code == 400){
					window.plugins.toast.show('当前密码不正确',"short",'center');
				}
				if(response.code == 200){
					App.utils.backPage();
					window.plugins.toast.show('密码修改成功',"short",'center');
				}
			},1000);
		});	
	}

	return {
		init:init
	};
	
});