define(['app','hbs!js/setting/init', 'js/mark'],function(App, InitView, Mark){
	
	var bindings = [{
		element: '.page[data-page="setting"]',
		selector: '.setpass',
		event: 'click',
		handler: openThisPage
	},{
		element: '.page[data-page="setting"]',
		selector: '.aboutus',
		event: 'click',
		handler: openAboutusPage
	},{
		element: '.page[data-page="setting"]',
		selector: '.gethelp',
		event: 'click',
		handler: openGethelpPage
	},{
		element: '.page[data-page="setting"]',
		selector: '.userrule',
		event: 'click',
		handler: openUserrulePage
	},{
		element: '.page[data-page="setting"]',
		selector: '.feedback',
		event: 'click',
		handler: openThisPage
	},{
		element: '.page[data-page="setting"]',
		selector: '.version',
		event: 'click',
		handler: openThisPage
	},{
		element: '.page[data-page="setting"]',
		selector: '.exitlogin',
		event: 'click',
		handler: exitLogin
	}];
	
	var about_us_url;
	var get_help_url;
	var user_rule_url;
	
	function init(){
		getInitInfo();
		App.utils.bindEvents(bindings);
	}
	
	function getInitInfo(){
		var staticInfo = Mark.getStaticInfo();
		about_us_url = staticInfo.about_us_url;
		get_help_url = staticInfo.get_help_url;
		user_rule_url = staticInfo.user_rule_url;
			
		var content = InitView();
		var container = $$('.page[data-page="setting"]');
		container.find('.content-setting').html(content);		
	}
	
	function openAboutusPage(){
		var appInfo = Mark.getAppInfo();
		var version = appInfo.version;
		var options = App.utils.getBrowserOptions('关于我们');
		cordova.ThemeableBrowser.open(about_us_url + '?version=' + version, '_blank', options);	
	}

	function openGethelpPage(){
		var options = App.utils.getBrowserOptions('使用帮助');
		cordova.ThemeableBrowser.open(get_help_url, '_blank', options);	
	}
	
	function openUserrulePage(){
		var options = App.utils.getBrowserOptions('用户协议');
		cordova.ThemeableBrowser.open(user_rule_url, '_blank', options);	
	}
	
	function openThisPage(){
		var pageUrl = $$(this).data('url');
		App.utils.loadPage(pageUrl);
	}
	
	function exitLogin(){
		App.utils.backPage();
		
		var pageUrl = $$(this).data('url');
		var currentPlatId = Mark.getCurrentPlatId();
		
		setTimeout(function(){
			if(currentPlatId == '1'){
				YCWeibo.logout();		
			}else if( currentPlatId == '2' ){
				YCQQ.logout();
			}else{
				//	
			}
			localStorage.removeItem('markInfo');
			userView.router.reloadPage(pageUrl);
		},1000);
	}
	
	return {
		init:init	
	};
	
});