define(['app','hbs!js/share/init', 'js/share/service'],function(App, InitView, Service){
	
	var bindings = [{
		element: '.share-friend',
		event: 'click',
		handler: checkFriend
	},{
		element: '.share-wechat',
		event: 'click',
		handler: checkWechat
	},{
		element: '.share-qq',
		event: 'click',
		handler: checkQQ
	},{
		element: '.share-qqzone',
		event: 'click',
		handler: checkQQzone
	},{
		element: '.share-weibo',
		event: 'click',
		handler: checkWeibo
	},{
		element: '.share-link',
		event: 'click',
		handler: shareLink
	},{
		element: '.close-button',
		event: 'click',
		handler: closePopup
	}];
	
	var typeId;
	var itemId;
	
	function init(query){
		if(!query.itemId)
		return;
		
		typeId = query.typeId;
		itemId = query.itemId;
		
		t7.popup(InitView());
		App.utils.bindEvents(bindings);
	}
	
	//===========================客户端安装情况============================
	
	//朋友圈
	function checkFriend(){
		Wechat.isInstalled(function (installed) {
			if (installed){
				shareToFriend();
			} else {
				window.plugins.toast.show('您没有安装微信',"short",'center');
			}
		},function(reason) {
			window.plugins.toast.show('您没有安装微信或版本过低',"short",'center');
		});
	}
	
	//微信好友
	function checkWechat(){
		Wechat.isInstalled(function (installed) {
			if (installed){
				shareToWechat();
			} else {
				window.plugins.toast.show('您没有安装微信',"short",'center');
			}
		}, function (reason) {
			window.plugins.toast.show('您没有安装微信或版本过低',"short",'center');
		});	
	}
	
	//QQ
	function checkQQ(){
		YCQQ.checkClientInstalled(function(){
			shareToQQ();
		},function(){
			window.plugins.toast.show('您没有安装QQ',"short",'center');
		});
	}
	
	//QQZONE
	function checkQQzone(){
		YCQQ.checkClientInstalled(function(){
			shareToQQzone();
		},function(){
			window.plugins.toast.show('您没有安装QQ',"short",'center');
		});
	}
	
	//微博
	function checkWeibo(){
		YCWeibo.checkClientInstalled(function(){
			shareToWeibo();
		},function(){
			window.plugins.toast.show('您没有安装微博',"short",'center');
		});
	}
	
	//===========================分享内容=============================
	
	//朋友圈
	function shareToFriend(){
		t7.showIndicator();
		var message = {};
		Service.getShareInfo(typeId, itemId, function(response){
			message.title = response.title;
			message.description = response.description;
			message.thumb = response.imageUrl;
			message.media = {
				type: Wechat.Type.LINK,
            	webpageUrl: response.url
			}
			Wechat.share({ 
				message: message, 
				scene: Wechat.Scene.TIMELINE
			}, shareSuccess, shareFail);
		});	
	}
	
	//微信好友
	function shareToWechat(){
		t7.showIndicator();
		var message = {};
		Service.getShareInfo(typeId, itemId, function(response){
			message.title = response.title;
			message.description = response.description;
			message.thumb = response.imageUrl;
			message.media = {
				type: Wechat.Type.LINK,
            	webpageUrl: response.url
			}
			Wechat.share({ 
				message: message, 
				scene: Wechat.Scene.SESSION
			}, shareSuccess, shareFail);
		});
	}
	
	//微博
	function shareToWeibo(){
		t7.showIndicator();
		var message = {};
		Service.getShareInfo(typeId, itemId, function(response){
			message.url = response.url;
			message.title = response.title;
			message.description = response.description;
			message.imageUrl = response.imageUrl;
			message.defaultText = response.title;
			YCWeibo.shareToWeibo( shareSuccess, shareFail, message);
		});
	}
	
	//QQ好友
	function shareToQQ(){
		t7.showIndicator();
		var message = {};
		Service.getShareInfo(typeId, itemId, function(response){
			message.url = response.url;
			message.title = response.title;
			message.description = response.description;
			message.imageUrl = response.imageUrl;
			message.appName = response.appName;
			YCQQ.shareToQQ( shareSuccess, shareFail, message);
		});
	}
	
	//QQ空间
	function shareToQQzone(){
		t7.showIndicator();
		var message = {};
		Service.getShareInfo(typeId, itemId, function(response){
			message.url = response.url;
			message.title = response.title;
			message.description = response.description;
			message.imageUrl = response.imageUrl;
			YCQQ.shareToQQ( shareSuccess, shareFail, message);
		});
	}
	
	//链接
	function shareLink(){
		Service.getShareInfo(typeId, itemId, function(response){
			var copyUrl = response.url;	 
			cordova.plugins.clipboard.copy(copyUrl,function(){
				window.plugins.toast.show('复制成功',"short",'center');
			},function(){
				window.plugins.toast.show('复制失败',"short",'center');
			});
		});
	}
	
	function shareSuccess(){
		t7.hideIndicator();
		window.plugins.toast.show('分享成功',"short",'center');
	}
	
	function shareFail(){
		t7.hideIndicator();
		window.plugins.toast.show('分享失败',"short",'center');
	}
	
	function closePopup(){
		t7.closeModal('.popup-share');	
		t7.hideIndicator();
	}
	
	return {
		init:init	
	};
	
});