define(function() {
	
	//funciton
	function bindEvents(bindings) {
		for (var i in bindings) {
			if(bindings[i].selector) {
				$$(bindings[i].element)
					.on(bindings[i].event,bindings[i].selector , bindings[i].handler);
			}else{
				$$(bindings[i].element)
					.on(bindings[i].event, bindings[i].handler);
			}
		}
	}
	
	function isPhoneGap() {
		return (window.cordova || window.PhoneGap || window.phonegap) 
		&& /^file:\/{3}[^\/]/i.test(window.location.href) 
		&& /ios|iphone|ipod|ipad|android/i.test(navigator.userAgent);
	}

	function isEmpty(obj) {
		for(var prop in obj) {
			if(obj.hasOwnProperty(prop))
				return false;
		}
		return true;
	}
	
	function isEmail(str){
        var reg = /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((\.[a-zA-Z0-9_-]{2,3}){1,2})$/;
        return reg.test(str);
    }
	
	function getCharLength(str){
		var iLength = 0;
		for ( var i = 0; i < str.length; i++){
			if( str.charCodeAt(i) > 255){
				iLength += 2;
			}else{
				iLength += 1;	
			}
		}
		return iLength;
	}
	
	function getUrlParam(paraName,url) {
		var arrObj = url.split("?");
		if (arrObj.length > 1) {
			var arrPara = arrObj[1].split("&");
			var arr;
			for (var i = 0; i < arrPara.length; i++) {
				arr = arrPara[i].split("=");
				if (arr != null && arr[0] == paraName) {
					return arr[1];
				}
			}
			return "";
		}
		else {
			return "";
		}
	} 
	
	function checkConnection(){
		var networkState = navigator.connection.type;
		
		var states = {};
		states[Connection.UNKNOWN]  = 'Unknown connection';
		states[Connection.ETHERNET] = 'Ethernet connection';
		states[Connection.WIFI]     = 'WiFi connection';
		states[Connection.CELL_2G]  = 'Cell 2G connection';
		states[Connection.CELL_3G]  = 'Cell 3G connection';
		states[Connection.CELL_4G]  = 'Cell 4G connection';
		states[Connection.CELL]     = 'Cell generic connection';
		states[Connection.NONE]     = 'No network connection';

		return states[networkState];	
	}
	
	
	function loadPage(url){
		var viewInfo = t7.getCurrentView();
		var currentView = viewInfo['selector'];
		currentView = currentView.replace(/#/ig,"");
		switch (currentView){
		case 'index':
			mainView.router.loadPage(url);
			break;
		case 'finding':
			findingView.router.loadPage(url);
			break;
		case 'category':
			categoryView.router.loadPage(url);
			break;
		case 'user':
			userView.router.loadPage(url);
			break;
		}
	}
	
	function showPreloader(elem){
		var queryElem = elem;
		if ( typeof elem == 'string' ) {
			queryElem = document.querySelectorAll( elem );
		}
		// bail if bad element
		if ( !queryElem ) {
			console.error( 'Bad element for Preloader ' + ( queryElem || elem ) );
			return;
		}
		
		queryElem.find('.infinite-scroll-preloader').show();
	}
	
	function hidePreloader(elem){
		var queryElem = elem;
		if ( typeof elem == 'string' ) {
			queryElem = document.querySelectorAll( elem );
		}
		// bail if bad element
		if ( !queryElem ) {
			console.error( 'Bad element for Preloader ' + ( queryElem || elem ) );
			return;
		}
		
		queryElem.find('.infinite-scroll-preloader').hide();
	}
	
	function startToolbar(){
		$$(".toolbar .toolbar-disabled").hide();
	}
	
	function stopToolbar(){
		$$(".toolbar .toolbar-disabled").show();
		 
	}
	
	function scrollTop(){
		var pageContent = $$('.views').find('.page:not(.page-on-left):not(.page-on-right):not(.cached)').find('.page-content');
		pageContent.scrollTop(0, 300);
	}
	
	function backPage(){
		userView.router.back();	
	}
	
	function getCurrentView(){
		var viewInfo = t7.getCurrentView();
		var currentView = viewInfo['selector'];
		currentView = currentView.replace(/#/ig,"");
		return currentView;
	}
		
	function getBrowserOptions(title){
		 var browserOptions = {
		 	toolbar: { 
				image:'toolbar', 
				height:50, 
				color:'#ffffff'
			},
			closeButton: {
				image: 'close',
				align: 'left',
				event: 'closePressed'
			},
			title: {
				color:'#666666',
				staticText:title
			}
		}
		return browserOptions;	
	}
	
	function message(message){
		window.plugins.toast.show( message, "short", 'center');
	}
	
	function getTaobaoUrl(url){
		var arrObj = url.split("/");
		var taoUrl = arrObj[2];
		if( taoUrl == "detail.m.tmall.com"){
			return true;
		}else if(taoUrl == "h5.m.taobao.com"){
			return true;
		}else{
			return false;	
		}
	}
	
	//return
	return{
		bindEvents: bindEvents,
		isPhoneGap:isPhoneGap,
		checkConnection: checkConnection,
		getBrowserOptions:getBrowserOptions,
		getCharLength:getCharLength,
		getCurrentView:getCurrentView,
		getTaobaoUrl:getTaobaoUrl,
		getUrlParam:getUrlParam,
		scrollTop:scrollTop,
		isEmpty:isEmpty,
		isEmail:isEmail,
		loadPage:loadPage,
		backPage:backPage,
		message:message,
		showPreloader:showPreloader,
		hidePreloader:hidePreloader,
		startToolbar:startToolbar,
		stopToolbar:stopToolbar
	};
	
});