define(['app','hbs!js/version/init', 'js/mark', 'js/version/service'],function(App, InitView, Mark, Service){

	var bindings = [{
		element: '.page[data-page="version"]',
		selector: '.submit',
		event: 'click',
		handler: updateVersion
	}];
	
	var curVersion;
	var newVersion;
	
	function init(){
		getVersionInfo();
		App.utils.bindEvents(bindings);
	}
	
	function getVersionInfo(){
		Service.getVersionInfo(function(response){
			getInitInfo(response.number);
		});	
	}
		
	function getInitInfo(version){
		newVersion = version;
		var appInfo = Mark.getAppInfo();
		curVersion = appInfo.version;
		
		var output = {};
		output.new_version = newVersion;
		output.current_version = curVersion;
		output.is_update = newVersion > curVersion ? true : false;
		
		var content = InitView(output);
		var container = $$('.page[data-page="version"]');
		container.find('.content-version').html(content);
	}

	function updateVersion(){
		var staticInfo = Mark.getStaticInfo();
		var updateUrl = encodeURI(staticInfo.app_update_url);
		var fileName = Math.random().toString(36).substr(2);
		
		if(newVersion > curVersion){
			requestfile(updateUrl,fileName);
		} else {
			window.plugins.toast.show('当前已经是最新版本，不用更新啦',"short",'center');
		}
	}
	
	function requestfile(fileUrl, fileName){
		window.requestFileSystem(window.TEMPORARY, 5 * 1024 * 1024, function (fileSystem){
			fileSystem.root.getFile( fileName + '.apk', { create: true, exclusive: false }, function (fileEntry) {
				downloadfile(fileEntry, fileUrl);
			}, onErrorCreateFile);
		}, onErrorLoadFs);	
	}
	
	function downloadfile(fileEntry, uri){
		var fileHosts = null;
		var fileOptions = {};
		var fileURL = fileEntry.toURL();
		var fileTransfer = new FileTransfer;
		fileTransfer.download( uri, fileURL, onWinFile, onFailFile, fileHosts,fileOptions);
	}
	
	function onWinFile(entry){
		cordova.plugins.fileOpener2.open(entry.toURL(),'application/vnd.android.package-archive');
	}
	
	function onFailFile(){
		window.plugins.toast.show('安装包下载失败，请清理缓存',"short",'center');
	}
	
	function onErrorCreateFile(){
		window.plugins.toast.show('安装包下载失败，请清理缓存',"short",'center');
	}
	
	function onErrorLoadFs(){
		window.plugins.toast.show('安装包下载失败，请清理缓存',"short",'center');
	}

	
	
	return {
		init:init
	};
	
});