define(["app",'js/wechat/service','js/mark'], function(App, Service, Mark) {
	
	
	function init(){
		checkClient();
	}
	
	function checkClient(){
		Wechat.isInstalled(function (installed) {
			if(installed) {
				clientLogin();
			}else {
				window.plugins.toast.show('您没有安装微信',"short",'center');
			}
		}, function (){
			window.plugins.toast.show('检测失败,请重新启动',"short",'center');
		});
	}
	
	function clientLogin(){
		t7.showIndicator();
		var scope = "snsapi_userinfo";
		var appInfo = Mark.getAppInfo();
		Wechat.auth(scope, function (response) {
			var response = JSON.stringify(response);
			var results = JSON.parse(response);
			var code = results.code;
			setTimeout(function(){
				Service.clientLogin(code,appInfo,function(response){
					successLogin(response);	
				});
			},1200);
		},function(){
			window.plugins.toast.show('取消微信登录',"short",'center');
			t7.hideIndicator();
		});
	}

	function successLogin(response){
		Mark.setCurrentMark(response);
		var homeUrl = 'page/home.html';
		var pageUrl = 'page/user.html';
		mainView.router.loadPage(homeUrl);
		userView.router.reloadPage(pageUrl);
		t7.hideIndicator();
		t7.closeModal();
	}	
	
	return {
		init:init
	};



});