define(["app",'js/weibo/service','js/mark'], function(App, Service, Mark) {
	
	
	function init(){		
		YCWeibo.checkClientInstalled(function(){
			clientLogin();
		},function(){
			browserLogin();
		});
	}
	
	function clientLogin(){
		t7.showIndicator();
		
		var appInfo = Mark.getAppInfo();
		YCWeibo.ssoLogin(function(args){
			var userId = args.userid;
			var accessToken = args.access_token;
			setTimeout(function(){
				Service.clientLogin(userId, accessToken, appInfo,function(response){
					successLogin(response);
				});	
			},1200);
		},function(){
			window.plugins.toast.show('取消登录',"short",'center');
			t7.hideIndicator();
		});	
	}
	
	function browserLogin(){
		var settingsInfo = Mark.getStaticInfo();
		var options = App.utils.getBrowserOptions('微博登录');
		var AppBrowser = cordova.ThemeableBrowser.open(settingsInfo.oauth_weibo_url, '_blank', options);
		
		AppBrowser.addEventListener('loadstart', function(response) {
			var oauthCode = App.utils.getUrlParam('code',response.url);
			if(oauthCode || oauthCode !== ''){
				openBrowserLogin(oauthCode);
				AppBrowser.close();
			}
		});
		
		AppBrowser.addEventListener('closePressed', function(response) {
			window.plugins.toast.show('取消登录',"short",'center');
		});
	}
	
	function openBrowserLogin(oauthCode){
		t7.showIndicator();
		
		var appInfo = Mark.getAppInfo();
		setTimeout(function(){
			Service.browserLogin(oauthCode,appInfo,function(response){	
				successLogin(response);
			});	
		},1200);
	}

	function successLogin(response){
		Mark.setCurrentMark(response);
		var homeUrl = 'page/home.html';
		var pageUrl = 'page/user.html';
		mainView.router.loadPage(homeUrl);
		userView.router.reloadPage(pageUrl);
		t7.hideIndicator();
		t7.closeModal();
	}

	return {
		init:init
	};



});