define(["app",'hbs!js/welcome/init','js/welcome/service','js/mark'], function(App, InitView, Service, Mark) {
	
	var bindings = [{
		element: '.popup-welcome',
		selector: '.btn-weibo',
		event: 'click',
		handler: weiboLogin
	},{
		element: '.popup-welcome',
		selector: '.btn-qzone',
		event: 'click',
		handler: qzoneLogin
	},{
		element: '.popup-welcome',
		selector: '.btn-wechat',
		event: 'click',
		handler: wechatLogin
	},{
		element: '.popup-welcome',
		selector: '.btn-register',
		event: 'click',
		handler: openRegisterPage
	},{	
		element: '.popup-welcome',
		selector: '.btn-login',
		event: 'click',
		handler: openLoginPage
	}];
		
	//加载欢迎页
	function init(){
		getInitInfo();		
	}
	
	function getInitInfo(){
		Service.getInitInfo(function(response){
			renderInitInfo(response);
		});	
	}
	
	function renderInitInfo(response){
		var output = {};
		output.cover_url = response.cover_url;
		
		var content = InitView(output);
		t7.popup(content);
		
		App.utils.bindEvents(bindings);
		checkWechat();
	}
	
	function openLoginPage(){
		App.router.load('login');
		return;
	}
	
	function openRegisterPage(){
		App.router.load('register');
		return;
	}
	
	//是否安装微信
	function checkWechat(){
		var container = $$('.popup-welcome');
		var setButtons = container.find('.wel-social');
		Wechat.isInstalled(function(installed){
			if(installed){
				setButtons.removeClass('social-v1').addClass('social-v2');
			}else{
				setButtons.removeClass('social-v2').addClass('social-v1');	
			}
		});	
	}
	
	
	//第三方登录
	function wechatLogin(){
		App.router.load('wechat');
	}
	
	function weiboLogin(){
		App.router.load('weibo');
	}

	function qzoneLogin(){
		App.router.load('qzone');
	}
	
	return {
		init:init
	};



});