define(['app'],function(App) {
	
	//function
	function searchCode(code, array){
		for (var i=0;i< array.length; i++){
			if (array[i].code === code) {
				return array[i];
			}
		}
		return false;
	}
	
	function getApiServer(){
		var severHost;
		if(App.utils.isPhoneGap()){
			severHost = 'http://www.tugebuy.com';	
		} else {
			severHost = 'http://www.tugebuy.com';
		}
		return severHost;
	}
	
	function getRequestURL(options){
		var host = getApiServer();
		var query = options.query || {};
		var module = options.module || '';
		var func = options.func || '';

		var apiServer = host + '/api/13/' + module + '/' + func + '.json' + (App.utils.isEmpty(query) ? '' : '?');
		var name;
		for (name in query) {
			apiServer += name + '=' + query[name] + '&';
		}
		//Return Api url
		return apiServer.replace(/&$/gi, '');
	}
	
	function getRequestCall(options, callback){		
		options = options || {};
		options.data = options.data ? options.data : '';
		options.method = options.method || 'POST';
		
		//inApp
		if(App.utils.isPhoneGap()){
			 //Check network connection
			var network = App.utils.checkConnection();
			if(network === 'No network connection'){
				$$('.not-network').show();
				t7.hideIndicator();
				t7.hidePreloader();	
			}
		}

		$$.ajax({
			url: getRequestURL(options) ,
			method: options.method,
			data: options.data,
			success:function(data){
				data = data ? JSON.parse(data) : '';
				
				var codes = [
					{code:400, message:'数据请求错误'}
				];
				
				//Error Code
				var codeLevel = searchCode(data.code,codes);
				
				if(!codeLevel){
					(typeof(callback) === 'function') ? callback(data) : '';
				} else {
					//Error Prompt
					t7.hideIndicator();
					t7.hidePreloader();
				}
			}
		});
	}
		
	//return
	return {
		getCall:getRequestCall
	};
	
});